
unit LYBase;

{
  This module is part of TP Lex/Yacc hacked for
  Delphi 2+ compatibility. It contains procedures
  common in LexBase and YaccBase units, especially
  damned NewStr.

  This module is Copyright (c) Albert Graef 1992
  Copyright (c) Alexey Mahotkin 1998
}

interface

type
  StrPtr = ^String;

function newStr(str : String) : StrPtr;
  (* creates a string pointer (only the space actually needed for the given
     string is allocated) *)

implementation {$IFDEF WIN32} uses SysUtils; {$ENDIF}
  

{$IFDEF WIN32}

function newStr(str : String) : StrPtr;
begin
Result := StrPtr(SysUtils.NewStr(str));
end;

{$ELSE}

function newStr(str : String) : StrPtr;
  var strp : StrPtr;
begin
  getmem(strp, succ(length(str)));
  move(str, strp^, succ(length(str)));
  newStr := strp;
end(*newStr*);

{$ENDIF}

end.
